/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief USBҰ
//!
//!  ̧ق͋Lqq\ʂĉpBɎʂUSBҰ܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB162, AT90USB82
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"

#include "lib_mcu/usb/usb_drv.h"
#include "usb_descriptors.h"
#include "modules/usb/device_chap9/usb_standard_request.h"
#include "usb_specific_request.h"
#if ((USB_DEVICE_SN_USE==ENABLE) && (USE_DEVICE_SN_UNIQUE==ENABLE))
#include "lib_mcu/flash/flash_drv.h"
#endif

//_____ ϸ ________________________________________________________________

//_____ ` _______________________________________________________________

// usb_user_device_descriptor
code S_usb_device_descriptor usb_dev_desc =
{
	sizeof(usb_dev_desc),
	DESCRIPTOR_DEVICE,
	Usb_write_word_enum_struc(USB_SPECIFICATION),
	DEVICE_CLASS,
	DEVICE_SUB_CLASS,
	DEVICE_PROTOCOL,
	EP_CONTROL_LENGTH,
	Usb_write_word_enum_struc(VENDOR_ID),
	Usb_write_word_enum_struc(PRODUCT_ID),
	Usb_write_word_enum_struc(RELEASE_NUMBER),
	MAN_INDEX,
	PROD_INDEX,
	SN_INDEX,
	NB_CONFIGURATION
};

// usb_user_configuration_descriptor FS
code S_usb_user_configuration_descriptor usb_conf_desc =
{
	{
		sizeof(S_usb_configuration_descriptor),
		DESCRIPTOR_CONFIGURATION,
		Usb_write_word_enum_struc(sizeof(S_usb_user_configuration_descriptor)),
		NB_INTERFACE,
		CONF_NB,
		CONF_INDEX,
		CONF_ATTRIBUTES,
		MAX_POWER
	},
	{
		sizeof(S_usb_interface_descriptor),
		DESCRIPTOR_INTERFACE,
		INTERFACE_NB_KBD,
		ALTERNATE_KBD,
		NB_ENDPOINT_KBD,
		INTERFACE_CLASS_KBD,
		INTERFACE_SUB_CLASS_KBD,
		INTERFACE_PROTOCOL_KBD,
		INTERFACE_INDEX_KBD
	},

// usb_user_manufacturer_string_descriptor
code S_usb_manufacturer_string_descriptor usb_user_manufacturer_string_descriptor =
{
	sizeof(usb_user_manufacturer_string_descriptor),
	DESCRIPTOR_STRING,
	USB_MANUFACTURER_NAME
};

// usb_user_product_string_descriptor
code S_usb_product_string_descriptor usb_user_product_string_descriptor =
{
	sizeof(usb_user_product_string_descriptor),
	DESCRIPTOR_STRING,
	USB_PRODUCT_NAME
};

// usb_user_serial_number
#if (USB_DEVICE_SN_USE==ENABLE)
code S_usb_serial_number usb_user_serial_number =
{
#if (USE_DEVICE_SN_UNIQUE==ENABLE)
	sizeof(usb_user_serial_number)+4*SN_LENGTH,
	DESCRIPTOR_STRING
#else
	sizeof(usb_user_serial_number),
	DESCRIPTOR_STRING,
	USB_SERIAL_NUMBER
#endif
};
#endif

// usb_user_language_id
code S_usb_language_id usb_user_language_id =
{
	sizeof(usb_user_language_id),
	DESCRIPTOR_STRING,
	Usb_write_word_enum_struc(LANGUAGE_ID)
};

#ifdef TG_DESKTOP
code S_usb_hid_report_descriptor_kbd usb_hid_report_descriptor_kbd =
{
	{
		0x05, 0x01,
		0x09, 0x06,
		0xA1, 0x01,
		0x05, 0x07,
		0x19, 0xE0,
		0x29, 0xE7,
		0x15, 0x00,
		0x25, 0x01,
		0x75, 0x01,
		0x95, 0x08,
		0x81, 0x02,
		0x95, 0x01,
		0x75, 0x08,
		0x81, 0x01,
		0x95, 0x05,
		0x75, 0x01,
		0x05, 0x08,
		0x19, 0x01,
		0x29, 0x05,
		0x91, 0x02,
		0x95, 0x01,
		0x75, 0x03,
		0x91, 0x01,
		0x95, 0x06,
		0x75, 0x08,
		0x15, 0x00,
		0x25, 0x65,
		0x05, 0x07,
		0x19, 0x00,
		0x29, 0x65,
		0x81, 0x00,
		0xC0
	}
};
#else
code S_usb_hid_report_descriptor_kbd usb_hid_report_descriptor_kbd =
{
	{
		0x05,0x01,			/* gp߰ (Wިį) */
		0x09,0x06,			/* p@ (ް)            */
		0xA1,0x01,			/* W (p)               */
		0x05,0x07,			/* gp߰ (ް)       */
		0x19,224,			/* gp ŏ (224)           */
		0x29,231,			/* gp ő (231)           */
		0x15,0x00,			/* _ ŏ (0)             */
		0x25,0x01,			/* _ ő (1)             */
		0x75,0x01,			/*  傫 (1)           */
		0x95,0x08,			/*   (8)               */
		0x81,0x02,			/*  (ްAϐA)   */
		0x81,0x01,			/*  (萔)               */
		0x19,0x00,			/* gp ŏ (0)             */
		0x29,101,			/* gp ő (101)           */
		0x15,0x00,			/* _ ŏ (0)             */
		0x25,101,			/* _ ő (101)           */
		0x75,0x08,			/*  傫 (8)           */
		0x95,0x06,			/*   (6)               */
		0x81,0x00,			/*  (ްAz)         */
		0x05,0x08,			/* gp߰ (LED)           */
		0x19,0x01,			/* gp ŏ (1)             */
		0x29,0x05,			/* gp ő (5)             */
		0x15,0x00,			/* _ ŏ (0)             */
		0x25,0x01,			/* _ ő (1)             */
		0x75,0x01,			/*  傫 (1)           */
		0x95,0x05,			/*   (5)               */
		0x91,0x02,			/* o (ްAϐA)   */
		0x95,0x03,			/*   (3)               */
		0x91,0x01,			/* o (萔)               */
		0xC0				/* WI                  */
	}
};
#endif
